''******************************
''* Retrosys Controller Driver *
''*       Version 1.0          *
''* (C) 2007 Shayne P. Helms   *
''******************************
CON
 A3      = 15 'MUX A3 Line
 A2      = 14 'MUX A2 Line
 A1      = 13 'MUX A1 Line
 A0      = 12 'MUX A0 Line
 CLK     = 11 'Controller CLK Line
 D       = 10 'MUX Data Line
 
VAR
 long cog
 long stack[32]
 byte data[32] 'Array for Holding Button Data
                           
PUB start : okay
''Start controller driver - starts a cog
''returns false if no cog available
 stop
  if cog
    cogstop(cog~ - 1)   
  okay := cog := cognew(scan, @stack) + 1
  
PUB stop
''Stop controller driver - frees a cog
 if cog
  cogstop(cog~ - 1)
  
PUB init
''Setup the proper pin directions
DIRA[A3]~~
DIRA[A2]~~
DIRA[A1]~~
DIRA[A0]~~
DIRA[CLK]~~
DIRA[D]~

PUB scan | ctr, puls
''Scan the controller ports and update the data array
init       
repeat
 puls := 0 'Pulse counter
 OUTA[CLK]~
 OUTA[A3]~~
 OUTA[A2]~~
 OUTA[A1]~~
 OUTA[A0]~~
 repeat puls from 1 to 3
  ctr := 0
  repeat 2
   !OUTA[CLK]
   repeat 2
    !OUTA[A3]
    repeat 2
     !OUTA[A2]
     repeat 2
      !OUTA[A1]
      repeat 2
       !OUTA[A0]
       if puls <> 3
        data[ctr] := INA[D] == 0
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 4 'These commands are for extra 3 button data, doesnt work with my controllers yet...
        data[0] := INA[D]
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 5
        data[1] := INA[D]
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 7
        data[2] := INA[D]
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 10
        data[16] := INA[D]
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 11
        data[17] := INA[D]
       if puls == 3 AND OUTA[CLK] == 1 AND ctr == 13
        data[18] := INA[D]
       ctr++
       waitcnt(clkfreq / 1000000 * 16 + cnt) 'delay 16 microseconds
  waitcnt(clkfreq / 1000 * 16 + cnt) 'delay 16 milliseconds for ~60Hz Freq.
  
PUB P1_ACTIVE
return (data[20])
PUB P2_ACTIVE
return (data[25])
PUB P1_UP
return (data[7])
PUB P1_DOWN
return (data[5])
PUB P1_A
return (data[22])
PUB P1_START
return (data[30])
PUB P2_UP
return (data[13])
PUB P2_DOWN
return (data[11])
PUB P2_A
return (data[28])
PUB P2_START
return (data[24])
PUB P1_LEFT
return (data[4])
PUB P1_RIGHT
return (data[15])
PUB P1_B
return (data[6])
PUB P1_C
return (data[14])
PUB P2_LEFT
return (data[10])
PUB P2_RIGHT
return (data[9])
PUB P2_B
return (data[12])
PUB P2_C
return (data[8])
PUB P1_X
return (data[0])
PUB P1_Y
return (data[1])
PUB P1_Z
return (data[2])
PUB P2_X
return (data[16])
PUB P2_Y
return (data[17])
PUB P2_Z
return (data[18])                                           